﻿package {
	
	import flash.display.*;
	import flash.events.Event;
	
	import org.libspark.flartoolkit.core.transmat.FLARTransMatResult;
	import org.libspark.flartoolkit.pv3d.FLARBaseNode;
	import org.libspark.flartoolkit.pv3d.FLARCamera3D;
	import org.papervision3d.render.LazyRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.view.stats.StatsView;
	import org.papervision3d.materials.*;
	
	public class PV3DARApp extends ARAppBase {
		
		private var _base;
		protected var _viewport:Viewport3D;
		protected var _camera3d:FLARCamera3D;
		protected var _scene:Scene3D;
		protected var _renderer:LazyRenderEngine;
		protected var _baseNode:FLARBaseNode;
		
		protected var _resultMat:FLARTransMatResult = new FLARTransMatResult();
		
		
		private var _switch_on_func:Function=null;
		private var _switch_off_func:Function=null;
		private var _execute_before_render:Function=null;
		private var _execute_after_render:Function=null;
		private var _cam_w:Number=0;
		private var _cam_h:Number=0;
		private var _first_add_items:Array=[];
		private var code_num:int=0;
		private var valids:Array=[];
		private var plane_mcs:Array=[];
		private var _ready:Boolean=false;
		private var baseNodeAr:Array=[];
		
		public function get switch_on_func():Function{
			return _switch_on_func;
		}
		public function set switch_on_func(v:Function){
			_switch_on_func=v;
		}
		
		public function get switch_off_func():Function{
			return _switch_off_func;
		}
		public function set switch_off_func(v:Function){
			_switch_off_func=v;
		}
		
		
		public function get execute_before_render():Function{
			return _execute_before_render;
		}
		public function set execute_before_render(v:Function){
			_execute_before_render=v;
		}
		
		public function get execute_after_render():Function{
			return _execute_after_render;
		}
		public function set execute_after_render(v:Function){
			_execute_after_render=v;
		}
		
		public function get valid_numbers():Array{
			return valids;
		}
		
		public function PV3DARApp(codeFiles:Array, pv3d_field, cam_w:Number=640, cam_h:Number=480){
			this.init('Data/camera_para.dat', codeFiles);
			code_num=codeFiles.length;
			this._base=pv3d_field;
			this._cam_w=cam_w;
			this._cam_h=cam_h;
			this._scene = new Scene3D();
		}
		
		public function createNewWorld():void{
			var no:int=baseNodeAr.length;
			baseNodeAr[no]= this._scene.addChild(new FLARBaseNode()) as FLARBaseNode;
		}
		/*
		public function addpvChild(item):void{
			//plane_mcs.push(item);
			if(this._baseNode==null){
				_first_add_items.push(item);
				return;
			}
			this._baseNode.addChild(item);
		}
		
		public function addpvMoveChild(item):void{
			plane_mcs.push(item);
			if(this._baseNode==null){
				_first_add_items.push(item);
				return;
			}
			this._baseNode.addChild(item);
		}
		*/
		public function addpvChildW(item, world_no:int):void{
			plane_mcs.push(item);
			if(!this._ready){
				_first_add_items.push({item:item, no:world_no});
				return;
			}
			baseNodeAr[world_no].addChild(item);
		}
		
		
		public function breakremovepvChild(item):void{
			item.material.destroy();
			removepvChild(item);
		}
		public function removepvChild(item):void{
			this._baseNode.removeChild(item);
		}
		
		protected override function onInit():void{
			super.onInit();
			
			this._base.addChild(this._capture);
			
			this._capture.width=_cam_w;
			this._capture.height=_cam_h;
			
			this._viewport = this._base.addChild(new Viewport3D(320, 240)) as Viewport3D;
			this._viewport.scaleX =_cam_w / 320;
			this._viewport.scaleY =_cam_h / 240;
			this._viewport.x = -4; // 4pix ???
			
			this._camera3d = new FLARCamera3D(this._param);
			
			//this._scene = new Scene3D();
			//this._baseNode= this._scene.addChild(new FLARBaseNode()) as FLARBaseNode;
			
			exe_first_items_add();
			
			this._renderer = new LazyRenderEngine(this._scene, this._camera3d, this._viewport);
			
//			this.stage.addChild(new StatsView(this._renderer));
			
			this.addEventListener(Event.ENTER_FRAME, this._onEnterFrame);
			
			this._ready=true;
		}
		
		private function exe_first_items_add():void{
			var a:int;
			var m:Object;
			
			//for(a=0;a<_first_add_items.length;a++)this._baseNode.addChild(_first_add_items[a]);
			for(a=0;a<_first_add_items.length;a++){
				m=_first_add_items[a];
				baseNodeAr[m.no].addChild(m.item);
			}
		}
		
		private function _onEnterFrame(e:Event = null):void {
			this._capture.bitmapData.draw(this._video);
			
			//var flg:Boolean=this._baseNode.visible;
			
			var a:int;
			var b:Number=0;
			var c:Number=0;
			var f:int=0;
			var border:Number=0.4
			valids=new Array();
			var h:int=0;
			var k:int;
			var nums:Array=[];
			
			var g:int=this._detector.detectMarkerLite(this._raster, 100);
			if(g){
				for(a=0;a<code_num;a++){
					b=this._detector.getConfidence(a);
					if(c<b){
						c=b;
						f=a;
					}
					if(b>border){
						valids.push(this._detector.getResult(a)._codeId);
					}
				}
				for(a=0;a<baseNodeAr.length;a++){
					baseNodeAr[a].visible = false;
				}
				for(a=0;a<valids.length;a++){
					b=valids[a];
					this._detector.getTransmationMatrix(a, this._resultMat);
					baseNodeAr[b].setTransformMatrix(this._resultMat);
					baseNodeAr[b].visible = true;
				}
				/*
				if(c>border){
					this._detector.getTransmationMatrix(f, this._resultMat);
					//this._detector.getTransformMatrix(f, this._resultMat);
					this._baseNode.setTransformMatrix(this._resultMat);
					this._baseNode.visible = true;
				}else{
					this._baseNode.visible = false;
				}
				*/
			} else {
				for(a=0;a<baseNodeAr.length;a++){
					baseNodeAr[a].visible = false;
				}
				//this._baseNode.visible = false;
			}
			
			//exe_switch_func(flg, this._baseNode.visible);
			
			
			if(_execute_before_render!=null)_execute_before_render();
			render();
			if(_execute_after_render!=null)_execute_after_render();
			
		}
		
		public function render():void{
			this._renderer.render();
		}
		
		private function exe_switch_func(prev_flg:Boolean, now_flg:Boolean):void{
			if(_switch_on_func!=null && !prev_flg && now_flg) _switch_on_func();
			if(_switch_off_func!=null && prev_flg && !now_flg) _switch_off_func();
		}
		
		
		public function set mirror(value:Boolean):void {
			if (value) {
				this._base.scaleX = -1;
				this._base.x = 640;
			} else {
				this._base.scaleX = 1;
				this._base.x = 0;
			}
		}
		
		public function get mirror():Boolean {
			return this._base.scaleX < 0;
		}
	}
}





























